use static_dir::static_dir;
use warp::{reject::Rejection, reply::Reply, Filter};

use self::state::SharedState;

pub mod state;

mod pages;
mod executor;

pub fn routes(state: SharedState) -> impl Filter<Extract = impl Reply, Error = Rejection> + Clone {
    pages::routes(state.clone())
        .or(executor::routes(state))
        .or(static_dir!("static"))
}