
use warp::{reject::Rejection, reply::{Html, Reply}, Filter};
use askama::Template;

use crate::SharedState;

use super::state::TemplateState;

#[derive(Template)]
#[template( path = "index.html" )]
pub struct Index {
    pub state: TemplateState
}

impl Index {
    pub async fn handler(state: SharedState) -> Result<Html<String>, Rejection> {
        let template = Index { 
            state: state.template
        };

        Ok(warp::reply::html(template.render().unwrap()))
    }
    
    pub fn filter(state: SharedState) -> impl Filter<Extract = impl Reply, Error = Rejection> + Clone {
        warp::path!()
            .and(warp::path::end())
            .and(warp::get())
            .map(move || state.clone())
            .and_then(Index::handler)
    }
}

pub fn routes(state: SharedState) -> impl Filter<Extract = impl Reply, Error = Rejection> + Clone {
    Index::filter(state)
}